<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/21/2004 *
 * ================                             Last change: 12/04/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-sql_patches.php                              *
 * -------------------------------------------------------------------- *
 * Short description : SQL fixes for pro versions                       *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Ausgelagertes "Profildaten aendern"              *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((ereg(basename(__FILE__), $_SERVER['PHP_SELF'])))
{
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Version number
$EXT_VERSION = "0.4.2";

// Auto-set extension version
if (!isset($EXT_VER)) $EXT_VER = $EXT_VERSION;

// Version history array (add more with , "0.1" and so on)
$EXT_VER_HISTORY = array("0.0", "0.0.1", "0.0.2", "0.0.3", "0.0.4", "0.0.5", "0.0.6", "0.0.7", "0.0.8", "0.0.9", "0.1.0", "0.1.1", "0.1.2", "0.1.3", "0.1.4", "0.1.5", "0.1.6", "0.1.7", "0.1.8", "0.1.9", "0.2.0", "0.2.1", "0.2.2", "0.2.3", "0.2.4", "0.2.5", "0.2.6", "0.2.7", "0.2.8", "0.2.9", "0.3.0", "0.3.1", "0.3.2", "0.3.3", "0.3.4", "0.3.5", "0.3.6", "0.3.7", "0.3.8", "0.3.9", "0.4.0", "0.4.1", "0.4.2");

switch ($EXT_LOAD_MODE)
{
case "register": // Do stuff when installtion is running (modules.php?module=admin&action=login is called)
	// SQL commands to run
	$SQLs[] = "";
	break;

case "remove": // Do stuff when removing extension
	// SQL commands to run
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_admin_menu WHERE
(action='theme' AND (what='theme_import' OR what='theme_edit')) OR
what='config_extensions' OR
what='config_home' OR
what='list_unconfirmed' OR
what='config_refid' OR
what='config_title' OR
what='sub_points' OR
what='config_admin' OR
what='list_norefs' LIMIT 12";
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_themes";
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_guest_menu WHERE action='themes' LIMIT 1";
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_member_menu WHERE
action='themes' OR
what='themes' OR
(action='stats' AND what='') OR
(action='extras' AND what='') OR
(action='rals' AND what='') OR
(action='account' AND what='') LIMIT 7";
	$SQLs[] = "UPDATE "._MYSQL_PREFIX."_member_menu SET action='main' WHERE
action='stats' OR
action='extras' OR
action='rals' OR
action='account'";
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_admin_menu_las";
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_admin_menu_las_data";
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_admin_menu_stats";
	break;

case "activate": // Do stuff when admin activates this extension
	// SQL commands to run
	$SQLs[] = "";
	break;

case "deactivate": // Do stuff when admin deactivates this extension
	// SQL commands to run
	$SQLs[] = "";
	break;

case "update": // Update an extension
	switch ($EXT_VER)
	{
	case "0.0.1": // SQL queries for v0.0.1
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD ext_autopurge enum('Y', 'N') not null default 'Y'";
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES ('setup', 'config_extensions', 'Erweitungsmanagement', 'Alle Einstellungen am Erweiterungsmanagement.', 10)";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Es kann nun bestimmt werden, ob vom Server gel&ouml;schte ext-xxx.php erkannt werden sollen und die verkn&uuml;pften Daten auch aus der Datenbank entfernt werden sollen.";
		break;

	case "0.0.2": // SQL queries for v0.0.2
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config CHANGE auto_purge auto_purge bigint(20) not null default '1209600'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "In der Tabelle <STRONG>mxchange_config</STRONG> musste die Spalte <STRONG>auto_purge</STRONG> (autom. L&ouml;schen von Best&auml;tigungsmails angepasst werden (war auf dem Testsystem auf tiny(4) gesetzt.)";
		break;

	case "0.0.3": // SQL queries for v0.0.3
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD points_word varchar(255) not null default 'Punkte'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Das Wort &quot;Punkte&quot; kann nun per Datenbank ge&auml;ndert werden. Damit k&ouml;nnen Sie anstelle des Wortes Punkte auch Klammlose oder &euro; schreiben.";
		break;

	case "0.0.4": // SQL queries for v0.0.4
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD mails_page bigint(20) not null default '10'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Anzahl Mails pro Seite in <STRONG>EMail-Details ansehen</STRONG> und <STRONG>EMail-Archiv</STRONG> hinzugef&uuml;gt.";
		break;

	case "0.0.5": // SQL queries for v0.0.5
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD index_home varchar(255) not null default 'welcome'";
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES ('setup', 'config_home', 'Home-Seite festlegen', 'Stellen Sie hier ein, welcher Men&uuml;punkt (what-welcome ist Standart) als Einstiegspunkt in das Men&uuml;system genutzt werden soll.', 5)";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Die what-welcome.php ist derzeit die &quot;Home&quot;-Seite (Eingangsseite). Dies kann nun per Datenbank ge&auml;ndert werden.";
		break;

	case "0.0.6": // SQL queries for v0.0.6
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_extensions ADD ext_has_css enum('Y', 'N') not null default 'N'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Es k&ouml;nnen nun SQL-Updates von einander abh&auml;ngig gemacht werden und die CSS-Datei kann per Admin-Bereich (wegen Debuggings) ein- bzw. ausgeschaltet werden.";
		break;

	case "0.0.7": // SQL queries for v0.0.7
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD verbose_sql enum('Y', 'N') not null default 'Y'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Die SQL-Anweisungen werden bei eingeschalteter Verbose-Funktion detailiert angezeigt.";
		break;

	case "0.0.8": // SQL queries for v0.0.8
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD menu_blur_spacer varchar(255) not null default '&nbsp;<STRONG><BIG>&middot;</BIG></STRONG>&nbsp;'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Nette Mouse-Hover-Effekte eingebaut (Anleitung <STRONG>MENUE_HOVER.txt</STRONG> zum Patchen der general.css bitte lesen!)";
		break;

	case "0.0.9": // SQL queries for v0.0.9
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES ('email', 'list_unconfirmed', 'Unbest. Mails auflisten', 'Schauen Sie sich hier unbest&auml;tigte Maillinks an. Bitte diesen Link nur &uuml;ber dem EMail-Archiv oder EMail-Details aufrufen, direkt aufgerufen bekommen Sie eine Fehlermeldung.', 8)";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Unbest&auml;tigte Maillinks k&ouml;nnen unter Email-Management -&gt; Unbest. Mails auflisten aufgelistet werden.";
		break;

	case "0.1.0": // SQL queries for v0.2.1
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD reg_points_mode enum('ref', 'direct') not null default 'ref'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Soll der einmalige Ref-Bonus &uuml;ber das Referral-System (also alle oberen Refs bekommen auch etwas davon ab) oder direkt dem Werber aufgebucht werden?";
		break;

	case "0.1.1": // SQL queries for v0.1.1
		$SQLs[] = "UPDATE "._MYSQL_PREFIX."_admin_menu SET title='Home-/Eingangsseite', descr='Stellen Sie hier ein, welcher Men&uuml;punkt (what-welcome ist Standart) als Einstiegspunkt in das Men&uuml;system genutzt werden soll und wie die automatische Weiterleitung in der Eingangsseite funktionieren soll.' WHERE what='config_home' LIMIT 1";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD index_delay tinyint(4) not null default '-1'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD index_cookie bigint(20) not null default '31536000'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Sie k&ouml;nnen nun <A href=\"".URL."/modules.php?module=admin&amp;what=config_home\">hier</A> die Verz&ouml;gerungszeit in der <A href=\"".URL."/index.php\">Eingangsseite</A> einstellen.";
		break;

	case "0.1.2": // SQL queries for v0.1.2
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES ('setup', 'config_refid', 'Standart-Ref-ID', 'Stellen Sie hier die User-ID ein, die genommen werden soll, wenn der Gast n icht per Referral-Link Ihren Mailtausch aufgerufen hat.', 7)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD def_refid bigint(20) not null default '0'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Standart Referral-ID kann per Admin-Bereich eingestellt werden (war vorher nur in modules.php und index.php direkt eingebbar.)";
		break;

	case "0.1.3": // SQL queries for v0.1.3
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD refid_target enum('register', 'index') not null default 'register'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Auf welche Seite soll der Ref-Link zeigen? Eingangsseite oder Anmeldeformular?";
		break;

	case "0.1.4": // SQL queries for v0.1.4
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD default_theme varchar(255) not null default '".GET_CURR_THEME()."'";
		$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_admin_menu WHERE action='theme' LIMIT 3";
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES ('theme', '', 'Themes', 'Verwalten Sie hier alle Designs (Themes) Ihres Mailtausch-Scriptes.', 8)";
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES ('theme', 'theme_import', 'Importieren', 'Es wird das Verzeichnis &quot;theme&quot; nach neuen Ordnern durchsucht und anschliessend in die Datenbank gesperrt aufgenommen.', 1)";
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES ('theme', 'theme_edit', 'Modifizieren', '&Auml;ndern Sie Titel, Freigaben usw. an den Themes. Sie k&ouml;nnen bis auf das Standart-Theme &quot;default&quot; auch Themes aus der Datenbank entfernen. Vorher sollten Sie es jedoch vom Server l&ouml;schen, damit es niht erneut importiert werden kann.', 2)";
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_guest_menu (action, what, title, sort, visible, locked) VALUES ('themes', '', 'Design-Auswahl', 4, 'Y', 'N')";
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (action, what, title, sort, visible, locked) VALUES ('themes', '', 'Design-Auswahl', 3, 'Y', 'N')";
		$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_themes";
		$SQLs[] = "CREATE TABLE "._MYSQL_PREFIX."_themes (
id bigint(20) not null auto_increment,
theme_path varchar(255) not null default '',
theme_active enum('Y', 'N') not null default 'N',
theme_ver varchar(255) not null default '0.0',
PRIMARY KEY(id)
) TYPE=MyISAM";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Theme-Support integriert. Bitte laden Sie sich zu dieser Version das <A href=\"http://www.mxchange.org\">281-Patch</A> (wenn Ihr Script v0.2.0-pre7 ist) herunter, da ansonsten die Themes nicht klappen werden!";
		break;

	case "0.1.5": // SQL queries for v0.1.5
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_extensions DROP ext_has_admin";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Spalte <U>ext_has_admin</U> aus der Tabelle <U>"._MYSQL_PREFIX."_extensions</U> entfernt, da sie keinen Sinn mehr macht.";
		break;

	case "0.1.6": // SQL queries for v0.1.6
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD enable_title_deco enum('Y', 'N') not null default 'Y'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD title_left varchar(10) not null default '[--'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD title_middle varchar(10) not null default '-'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD title_right varchar(10) not null default '--]'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD enable_mod_title enum('Y', 'N') not null default 'Y'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD enable_what_title enum('Y', 'N') not null default 'Y'";
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES ('setup', 'config_title', 'Seitentitel &auml;ndern', 'De-/aktivieren Sie hier die Dekorationen, sowie Modul-Titel und what-Titel im Seitentitel.', 8)";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Dekorationen des Seitentiteles lassen sich ein- und ausschalten und selber definieren; Modul-Titel und Titel der <STRONG>what</STRONG>-Dateien kann hinzugef&uuml;gt werden.";
		break;

	case "0.1.7": // SQL queries for v0.1.7
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.";
		break;

	case "0.1.8": // SQL queries for v0.1.8
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "mad_counter und last_mad werden nun aus der Datenbank geladen";
		break;

	case "0.1.9": // SQL queries for v0.1.9
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.";
		break;

	case "0.2.0": // SQL queries for v0.2.0
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_jackpot CHANGE points points double(22,5) not null default '0.00000'";

		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_payments CHANGE payment payment double(22,5) not null default '0.00000'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_payments CHANGE price price double(22,5) not null default '0.00000'";

		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data CHANGE used_points used_points double(22,5) not null default '0.00000'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_points CHANGE points points double(22,5) not null default '0.00000'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_points CHANGE locked_points locked_points double(22,5) not null default '0.00000'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "5 Nachkommastellen implementiert";
		break;

	case "0.2.1": // SQL queries for v0.2.1
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD css_php enum('DIRECT', 'FILE') not null default 'FILE'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Ausgabe der CSS-Dateien entweder per css.php oder sie sind direkt eingebunden.";
		break;

	case "0.2.2": // SQL queries for v0.2.2
		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Erweiterung bleibt wegen integrierten Schalters immer aktiv.";
		break;

	case "0.2.3": // SQL queries for v0.2.3
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD guest_menu enum('Y', 'N') not null default 'Y'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD member_menu enum('Y', 'N') not null default 'Y'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD youre_here enum('Y', 'N') not null default 'Y'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Gast- und Mitgliedsmen&uuml;s lassen sich getrennt voneinander abschalten.";
		break;

	case "0.2.4": // SQL queries for v0.2.4
		$auto_type = "png"; // PNG image is the default
		if ((file_exists(PATH."theme/".GET_CURR_THEME()."/images/code_bg.jpg")) && function_exists('imagecreatefromjpeg'))
		{
			// Switch to JPEG format
			$auto_type = "jpg";
		}
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD img_type enum('jpg', 'png') not null default '".$auto_type."'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Generierung des Mailbest&auml;tigungscodes h&auml;ngt davon ab, ob die PHP-Funktion <U>imagecreatefromjpeg()</U> und das JPEG-Bild vorhanden sind oder nicht.";
		break;

	case "0.2.5": // SQL queries for v0.2.5
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data CHANGE receive_mails receive_mails bigint(20) not null default '0'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data CHANGE max_mails max_mails bigint(20) not null default '0'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Spalten <U>max_mails</U> und <U>receive_mails</U> auf bigint(20) gesetzt.";
		break;

	case "0.2.6": // SQL queries for v0.2.6
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES ('user', 'sub_points', '{!POINTS!} abziehen', 'Allen oder einem Mitglied {!POINTS!} abziehen.', 8)";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Abzug von {!POINTS!} nun m&ouml;glich.";
		break;

	case "0.2.7": // SQL queries for v0.2.7
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (action, what, title, sort) VALUES ('main', 'themes', 'Designs', 6)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data ADD curr_theme varchar(255) not null default 'default'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD stats_limit bigint(20) not null default '10'";
		$SQLs[] = "UPDATE "._MYSQL_PREFIX."_admin_menu SET what='config_stats' WHERE what='stats' LIMIT 1";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "<OL>
<LI>Das Mitglied kann das derzeitige Design in sein Profil abspeichern.</LI>
<LI>Mitgliederstatistik mit Seitennavigation.</LI>
</OL>";
		break;

	case "0.2.8": // SQL queries for v0.2.8
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data ADD last_login varchar(10) not null default '0'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Letzter Login wird gespeichert, Cache wird bei installierter Cache-Erweiterung bei Sprachen&auml;nderung aufgefrischt.";
		break;

	case "0.2.9": // SQL queries for v0.2.9
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD mt_word varchar(255) not null default 'Mailtausch'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD mt_word2 varchar(255) not null default 'Mailtausches'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD mt_word3 varchar(255) not null default 'Mailtauscher'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "W&ouml;rter <STRONG>Mailtausch</STRONG>, <STRONG>Mailtausches</STRONG> und <STRONG>Mailtauscher</STRONG> sind austauschbar.";
		break;

	case "0.3.0": // SQL queries for v0.3.0
		$SQLs[] = "UPDATE "._MYSQL_PREFIX."_admin_menu SET title='{!POINTS!}/Referral-Ebenen' WHERE what='config_points' LIMIT 1";
		$SQLs[] = "UPDATE "._MYSQL_PREFIX."_admin_menu SET title='Mailverg&uuml;tungen...' WHERE what='payments' LIMIT 1";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Zwei Men&uuml;punkte umbenannt.";
		break;

	case "0.3.1": // SQL queries for v0.3.1
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_extensions ADD UNIQUE KEY (ext_name)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_themes ADD UNIQUE KEY (theme_path)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_themes ADD INDEX (theme_active)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_admins ADD UNIQUE KEY (login)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data ADD INDEX (status)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_refbanner ADD INDEX (visible)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_refdepths ADD UNIQUE KEY (level)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_refsystem ADD INDEX (level)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_pool ADD INDEX (data_type)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_mod_reg ADD UNIQUE KEY (module)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_admin_menu ADD INDEX (action)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_admin_menu ADD INDEX (what)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_task_system ADD INDEX (task_type)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_task_system ADD INDEX (status)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_task_system ADD INDEX (task_created)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_task_system ADD FULLTEXT (subject)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_task_system ADD INDEX (subject)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_extensions ADD INDEX (ext_active)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data ADD INDEX (status)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data ADD FULLTEXT (family)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data ADD INDEX (max_mails)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data ADD INDEX (password)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_guest_menu ADD INDEX (action)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_guest_menu ADD INDEX (what)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_guest_menu ADD INDEX (sort)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_guest_menu ADD INDEX (visible)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_guest_menu ADD INDEX (locked)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_member_menu ADD INDEX (what)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_member_menu ADD INDEX (sort)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_member_menu ADD INDEX (visible)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_member_menu ADD INDEX (locked)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_cats ADD INDEX (visible)";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_cats ADD INDEX (sort)";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Eindeutige Schl&uuml;ssel (UNIQUE KEY) und normale Schl&uuml;ssel (INDEX) gesetzt.";
		break;

	case "0.3.2": // SQL queries for v0.3.2
		// Connection table between the menu system and the "logical area" system
		$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_admin_menu_las";
		$SQLs[] = "CREATE TABLE "._MYSQL_PREFIX."_admin_menu_las (
id bigint(20) not null auto_increment,
la_id varchar(255) not null default '',
la_action varchar(255) not null default '',
la_what varchar(255) not null default '',
INDEX (la_id),
INDEX (la_action),
INDEX (la_what),
PRIMARY KEY(id)
) TYPE=MyISAM";
		// All "logical areas" together
		$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_admin_menu_las_data";
		$SQLs[] = "CREATE TABLE "._MYSQL_PREFIX."_admin_menu_las_data (
id bigint(20) not null auto_increment,
la_id varchar(255) not null default '',
la_title varchar(255) not null default '',
la_posx bigint(20) not null default '0',
la_posy bigint(20) not null default '0',
UNIQUE KEY (la_id),
INDEX (la_posx),
INDEX (la_posy),
PRIMARY KEY(id)
) TYPE=MyISAM";
		// Which menu do you like?
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD admin_menu enum('NEW', 'OLD') not null default 'OLD'";

		// Insert menus
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES ('setup', 'config_admin', 'Adminmen&uuml;', 'Diverse Einstellungen am Adminmen&uuml; vornehmen.', 9)";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Logische Bereiche (Logical Areas = LAs) eingef&uuml;hrt. Dadurch wird das immer st&auml;rker anwachsende Admin-Men&uuml; in grosse Hauptgruppen unterteilt, wodurch ein Auffinden von Men&uuml;punkten verbessert wird.";
		break;

	case "0.3.3": // SQL queries for v0.3.3
		// Switch of the "intelligent menu sorter" when you want to have a fixed menu structure...
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD admin_menu_sorter enum('Y', 'N') not null default 'Y'";

		// The statistics table
		$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_admin_menu_stats";
		$SQLs[] = "CREATE TABLE "._MYSQL_PREFIX."_admin_menu_stats (
id bigint(20) not null auto_increment,
aid bigint(20) not null default '0',
type enum('la', 'action', 'what') not null default 'what',
clicks bigint(20) not null default '0',
INDEX (aid),
PRIMARY KEY (id)
) TYPE=MyISAM";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Admin-abh&auml;ngig werden nun Klicks im Admin-Men&uuml; gez&auml;hlt, die zur automatischen Anpassung des Men&uuml;s in den logischen Bereichen diennen. Dieses &quot;intelligente Unbauen&quot; k&ouml;nnen Sie auch ganz abschalten.";
		break;

	case "0.3.4": // SQL queries for v0.3.4
		// List accounts with no referral
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (action, what, title, descr, sort) VALUES ('user', 'list_norefs', 'Mitglieder ohne Werber', 'Finden Sie hier alle Mitglieder-Accounts, die von niemandem ({--MAIN_TITLE--} wird in der Mail als Werber angegebenen) geworben wurden.', 7)";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "F&uuml;gt den Men&uuml;punkt &quot;Mitglieder ohne Werber&quot; in die Mitglieder-Management hinzu. Mit dieser neuen Funktion k&ouml;nnen Sie nach Mitglieder-Accounts ohne Werber suchen. TODO-ID #2 CLOSED";
		break;

	case "0.3.5": // SQL queries for v0.3.5
		// List accounts with no referral
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (action, what, title, sort, visible, locked) VALUES ('stats', '', 'Statistiken', 4, 'Y', 'N')";
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (action, what, title, sort, visible, locked) VALUES ('stats', 'stats2', 'Framekiller-Mails', 2, 'Y', 'N')";
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (action, what, title, sort, visible, locked) VALUES ('extras', '', 'Extras', 5, 'Y', 'N')";
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (action, what, title, sort, visible, locked) VALUES ('rals', '', 'Rallyes', 6, 'Y', 'N')";
		$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (action, what, title, sort, visible, locked) VALUES ('account', '', 'Ihr Account', 7, 'Y', 'N')";
		$SQLs[] = "UPDATE "._MYSQL_PREFIX."_member_menu SET sort='8' WHERE action='themes' LIMIT 1";
		$SQLs[] = "UPDATE "._MYSQL_PREFIX."_member_menu SET action='stats', sort='1', title='Klick-Mails' WHERE what='stats' LIMIT 1";
		$SQLs[] = "UPDATE "._MYSQL_PREFIX."_member_menu SET action='account', sort='1', title='Designs' WHERE what='themes' LIMIT 1";
		$SQLs[] = "UPDATE "._MYSQL_PREFIX."_member_menu SET action='extras', sort='3' WHERE what='reflinks' LIMIT 1";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Mitgliedsmen&uuml; komplett umgebaut.";
		break;

	case "0.3.6": // SQL queries for v0.3.6
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD salt_length tinyint(4) not null default '9'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD pass_scramble varchar(255) not null default ''";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data MODIFY password varchar(255) not null default ''";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_user_data MODIFY user_hash varchar(255) not null default ''";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_admins MODIFY password varchar(255) not null default ''";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD rand_no bigint(20) not null default '0'";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD file_hash varchar(255) not null default ''";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_config ADD master_salt varchar(255) not null default ''";
		$SQLs[] = "UPDATE "._MYSQL_PREFIX."_config SET rand_no=(ROUND(RAND() * 99999) + 100000) WHERE config=0 LIMIT 1";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_mod_reg ADD has_menu enum('Y', 'N') NOT NULL default 'N'";
		$SQLs[] = "UPDATE "._MYSQL_PREFIX."_mod_reg SET has_menu='Y' WHERE module='admin' OR module='index' OR module='login' LIMIT 3";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Passwort-System mit Zufallshash erweitert (Schutzt gegen Dictionary-Attacks!)";
		break;

	case "0.3.7": // SQL queries for v0.3.7
		$UPDATE_NOTES = "Problem w&auml;hrend des Installationsvorganges behoben.";
		break;

	case "0.3.8": // SQL queries for v0.3.8
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_admin_menu CHANGE descr descr MEDIUMTEXT NULL";
		$SQLs[] = "ALTER TABLE "._MYSQL_PREFIX."_pool CHANGE `text` `text` LONGTEXT NOT NULL";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Beschreibungstexte f&uuml;r Admin-Men&uuml;s k&ouml;nnen l&auml;nger sein. Diverse Fixes.";
		break;

	case "0.3.9": // SQL queries for v0.3.9
		$SQLs[] = "UPDATE  "._MYSQL_PREFIX."_admin_menu SET title = REPLACE(title, '--POINTS--', '!POINTS!') WHERE title LIKE '%--POINTS--%'";
		$SQLs[] = "UPDATE  "._MYSQL_PREFIX."_admin_menu SET descr = REPLACE(descr, '--POINTS--', '!POINTS!') WHERE descr LIKE '%--POINTS--%'";
		$SQLs[] = "UPDATE  "._MYSQL_PREFIX."_guest_menu SET title = REPLACE(title, '--POINTS--', '!POINTS!') WHERE title LIKE '%--POINTS--%'";
		$SQLs[] = "UPDATE  "._MYSQL_PREFIX."_member_menu SET title = REPLACE(title, '--POINTS--', '!POINTS!') WHERE title LIKE '%--POINTS--%'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Beschreibungstexte f&uuml;r Admin-Men&uuml;s k&ouml;nnen l&auml;nger sein. Diverse Fixes.";
		break;

	case "0.4.0": // SQL queries for v0.4.0
		$SQLs[] = "UPDATE "._MYSQL_PREFIX."_admin_menu SET title = 'Email-Management' WHERE action = 'email' AND what='' LIMIT 1";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Email-Verwaltung nach Email-Management umbenannt.";
		break;

	case "0.4.1": // SQL queries for v0.4.1
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_user_data` DROP INDEX `status` , ADD INDEX `status` ( `status` , `max_mails` )";
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_config` ADD `show_timings` ENUM ('Y','N') NOT NULL DEFAULT 'Y'";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "Tabellen-Schl&uuml;ssel neu gesetzt und Parsing-Zeit im Footer eingeblendet.";
		break;

	case "0.4.2": // SQL queries for v0.4.2
		$SQLs[] = "ALTER TABLE `"._MYSQL_PREFIX."_online` ADD INDEX `admin_member` (`is_admin`, `is_member`)";
		break;
	}
	break;

default: // Do stuff when extension is loaded
	$dummy = LOAD_CONFIG();

	// When the sql_patches is not installed we cannot load it's configuration... *sigh*
	if (GET_EXT_VERSION("sql_patches") != '') {
		$_CONFIG['ext_autopurge']     = $dummy['ext_autopurge'];
		$_CONFIG['mails_page']        = $dummy['mails_page'];
		$_CONFIG['index_home']        = $dummy['index_home'];
		$_CONFIG['verbose_sql']       = $dummy['verbose_sql'];
		$_CONFIG['middot']            = $dummy['menu_blur_spacer'];
		$_CONFIG['reg_points_mode']   = $dummy['reg_points_mode'];
		$_CONFIG['index_delay']       = $dummy['index_delay'];
		$_CONFIG['index_cookie']      = $dummy['index_cookie'];
		$_CONFIG['def_refid']         = $dummy['def_refid'];
		$_CONFIG['refid_target']      = $dummy['refid_target'];
		$_CONFIG['default_theme']     = $dummy['default_theme'];
		$_CONFIG['title_decoration']  = $dummy['enable_title_deco'];
		$_CONFIG['title_mod_show']    = $dummy['enable_mod_title'];
		$_CONFIG['title_what_show']   = $dummy['enable_what_title'];
		$_CONFIG['title_left']        = $dummy['title_left'];
		$_CONFIG['title_middle']      = $dummy['title_middle'];
		$_CONFIG['title_right']       = $dummy['title_right'];
		$_CONFIG['mad_counter']       = $dummy['mad_count'];
		$_CONFIG['last_mad']          = $dummy['mad_timestamp'];
		$_CONFIG['css_php']           = $dummy['css_php'];
		$_CONFIG['guest_menu']        = $dummy['guest_menu'];
		$_CONFIG['member_menu']       = $dummy['member_menu'];
		$_CONFIG['youre_here']        = $dummy['youre_here'];
		$_CONFIG['img_type']          = $dummy['img_type'];
		$_CONFIG['stats_limit']       = $dummy['stats_limit'];
		$_CONFIG['admin_menu']        = $dummy['admin_menu'];
		$_CONFIG['admin_menu_sorter'] = $dummy['admin_menu_sorter'];
		$_CONFIG['salt_length']       = $dummy['salt_length'];
		$_CONFIG['pass_scramble']     = trim($dummy['pass_scramble']);
		$_CONFIG['file_hash']         = trim($dummy['file_hash']);
		$_CONFIG['master_salt']       = trim($dummy['master_salt']);
		$_CONFIG['secret_key']        = "";
		$_CONFIG['show_timings']      = $dummy['show_timings'];

		// Read key from secret file
		if ((empty($_CONFIG['file_hash'])) || (empty($_CONFIG['master_salt'])) || (empty($_CONFIG['pass_scramble'])))
		{
			// Maybe need setup of secret key!
			require_once(PATH."inc/gen_sql_patches.php");

			if (GET_EXT_VERSION("cache") >= "0.1.2")
			{
				// Remove extensions and mod_reg cache file
				require_once(PATH."inc/libs/cache_functions.php");
				require_once(PATH."inc/extensions/ext-cache.php");
				if ($cacheInstance->cache_file("extensions", true)) $cacheInstance->cache_destroy();
				if ($cacheInstance->cache_file("mod_reg", true)) $cacheInstance->cache_destroy();
			}
		}

		// Test again
		if ((!empty($_CONFIG['file_hash'])) && (!empty($_CONFIG['master_salt'])) && (!empty($_CONFIG['pass_scramble'])))
		{
			// File hash fas generated so we can also file the secret file... hopefully.
			if ((file_exists(PATH."inc/.secret/.".$_CONFIG['file_hash'])) && (is_readable(PATH."inc/.secret/.".$_CONFIG['file_hash'])))
			{
				$_CONFIG['secret_key'] = implode("", file(PATH."inc/.secret/.".$_CONFIG['file_hash']));
			}
			 else
			{
				// Cannot read secret file!
				mxchange_die("Cannot read secret file!");
			}
		}

		// Transfer words/numbers to constants
		define('POINTS'  , $dummy['points_word']);
		define('MT_WORD' , $dummy['mt_word']);
		define('MT_WORD2', $dummy['mt_word2']);
		define('MT_WORD3', $dummy['mt_word3']);
		define('_MAX'    , $dummy['rand_no']);
	} else {
	   	// Set some lame ;-) default settings
		$_CONFIG['def_refid'] = 0;
		$_CONFIG['title_decoration'] = 'N';
		$_CONFIG['title_mod_show']   = 'Y';
		$_CONFIG['title_middle']     = "-";
		//$_CONFIG['verbose_sql']      = 'N';
		define('MT_WORD' , DEFAULT_MT_WORD );
		define('MT_WORD2', DEFAULT_MT_WORD2);
		define('POINTS'  , DEFAULT_POINTS);
	}

	// Remove dummy config array
	unset($dummy);
	break;
}

// Language file prefix (hmmm, what shall I write with SQL fixes? ;-) )
$EXT_LANG_PREFIX = "sql_patches";

// Extension is always active?
$EXT_ALWAYS_ACTIVE = 'Y';

//
?>